package org.mandarax.xkb.framework;

/**
 *  Copyright (C) 1999-2004  Jens Dietrich (mailto:mandarax@jbdietrich.com)
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

import java.util.Map;

import org.jdom.Element;
import org.mandarax.kernel.Fact;
import org.mandarax.kernel.LogicFactory;
import org.mandarax.kernel.Predicate;
import org.mandarax.kernel.Term;
import org.mandarax.xkb.XKBException;
/**
 * An adapter class for facts.
 * @see org.mandarax.kernel.Fact
 * @author <A HREF="mailto:mandarax@jbdietrich.com">Jens Dietrich</A>
 * @version 3.3.1 <9 August 2004>
 * @since 1.6 
 */

public class XMLAdapter4Facts extends AbstractXMLAdapter {
      public static final String TERMS = "terms";
      public static final String FACT = "atom";
      public static final String OPERATOR = "_opr";

/**
 * Export an object, i.e., convert it to an element in the DOM.
 * @param obj an object
 * @param driver the generic driver
 * @param cache a cache used in order to associate the same
 * id with various occurences of the same object
 * @exception an XKBException is thrown if export fails
 */
public Element exportObject(Object obj,GenericDriver driver,Map cache) throws  XKBException {
      check(obj,Fact.class);
      Fact fact = (Fact)obj;
      Element e = new Element(FACT);
      // add predicate
      Predicate p = fact.getPredicate();
      Element eo = new Element(OPERATOR);
      e.addContent(eo);
      Element ep = exportObject(p,getPredicateType(p),driver,cache);
      eo.addContent(ep);
      // add terms
      Term[] terms = fact.getTerms();
      Element eTerms = new Element(TERMS);
      e.addContent(eTerms);
      for (int i=0;i<terms.length;i++) {
            Element et = exportObject(terms[i],getTermType(terms[i]),driver,cache);
            eTerms.addContent(et);
      }
      return e;
}
/**
 * Build an object from an XML element.
 * @param e an element
 * @param driver the generic driver
 * @param cache a cache used to identify objects that have the same id
 * @param lfactory the logic factory used to create objects
 * @exception an XKBException is thrown if import fails
 */
public Object importObject(Element e,GenericDriver driver,Map cache,LogicFactory lfactory) throws XKBException {
       // the first element is predicate
       Element eOperator = e.getChild(OPERATOR);
       Element ePredicate = (Element)eOperator.getChildren().get(0);
       XMLAdapter adapter = driver.getAdapterByTagName(ePredicate.getName());
       Predicate predicate = (Predicate)adapter.importObject(ePredicate,driver,cache,lfactory);
       // get the terms
       Element eTerm = (Element)e.getChild(TERMS);
       Term[] terms = (Term[])importChildren(eTerm,null,driver,cache,lfactory,Term.class);
       // assemble fact
       return lfactory.createFact(predicate,terms);
}
/**
 * Get the name of the associated tag (element).
 * @return a string
 */
public String getTagName() {
      return FACT;
}
/**
 * Get the kind of object the adapter can export/import.
 * @return a string
 */
public String getKindOfObject() {
      return GenericDriver.FACT;
}

}
